<?php
/**
 * Created by PhpStorm.
 * User: mrs
 * Date: 15.01.2018
 * Time: 14:16
 */

namespace App\Repository;

use App\Model\Languages;

class LanguagesRepository extends RepositoryAbstract
{

    public function __construct()
    {
        parent::__construct();
        $this->entityName = 'languages';
    }

    /**
     * @param $id
     * @return null|Languages
     */
    public function findById($id)
    {
        $stmt = $this->pdo->prepare("SELECT * FROM {$this->entityName} WHERE id = :id");
        $stmt->execute(['id' => $id]);
        foreach ($stmt as $row) {
            return new Languages($row['name'], $row['id']);
        }
        return null;
    }

    /**
     * @return Languages[] array
     */
    public function findAll(): array
    {
        $stmt = $this->pdo->prepare("SELECT * FROM {$this->entityName}");
        $stmt->execute();
        $students = [];
        foreach ($stmt as $row) {
            $students[] = new Languages($row['name'], $row['id']);
        }
        return $students;
    }

    /**
     * @param Languages $languages
     */
    public function save(Languages $languages)
    {
        $stmt = $this->pdo->prepare("INSERT INTO {$this->entityName} (name) VALUES(:name)");
        $stmt->execute([
            'name' => $languages->name,

        ]);
    }

    /**
     * @param Languages $languages
     */
    public function update(Languages $languages)
    {
        $stmt = $this->pdo->prepare("UPDATE {$this->entityName} SET name = :name WHERE id = :id");
        $stmt->execute([
            'id' => $languages->id,
            'name' => $languages->name,
        ]);
    }


    /**
     * @param int $id
     */
    public function delete(int $id)
    {
        $stmt = $this->pdo->prepare("DELETE FROM {$this->entityName} WHERE id = :id");
        $stmt->execute(['id' => $id]);
    }

    /**
     * @param
     */

    public function deleteAll()
    {
        $stmt = $this->pdo->prepare("TRUNCATE TABLE {$this->entityName}");
        $stmt->execute();
    }


}